/* $Id: table.c,v 1.1.1.1 90/11/28 17:03:46 altenhof Exp $ */

/*
 * Copyright (C) 1990 by Digital Equipment Corporation.
 * 
 * Author: Michael P. Altenhofen, CEC Karlsruhe e-mail:
 * Altenhofen@kampus.enet.dec.com
 * 
 * This file ist part of Shared X
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation without fee is hereby granted, but only for non-profit  use
 * and distribution,  and provided  that the copyright notice and this notice
 * is preserved on all copies.
 * 
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
#include <X11/X.h>

#include "requests.h"

int (*RequestProcVector[128]) () = {
  ProcBadRequest,
  ProcCreateWindow,
  ProcChangeWindowAttributes,
  Dummy,
  ProcDestroyWindow,
  ProcDestroySubwindows,	/* 5 */
  ProcChangeSaveSet,
  ProcReparentWindow,
  ProcMapWindow,
  ProcMapSubwindows,
  ProcUnmapWindow,		/* 10 */
  ProcUnmapSubwindows,
  ProcConfigureWindow,
  ProcCirculateWindow,
  Dummy,
  Dummy,			/* 15 */
  Dummy,
  Dummy,
  ProcChangeProperty,
  ProcDeleteProperty,
  Dummy,			/* 20 */
  Dummy,
  ProcSetSelectionOwner,
  Dummy,
  ProcConvertSelection,
  ProcSendEvent,		/* 25 */
  Dummy,
  ProcUngrabPointer,
  ProcGrabButton,
  ProcUngrabButton,
  ProcChangeActivePointerGrab,	/* 30 */
  Dummy,
  ProcUngrabKeyboard,
  ProcGrabKey,
  ProcUngrabKey,
  ProcAllowEvents,		/* 35 */
  ProcGrabServer,
  ProcUngrabServer,
  Dummy,
  Dummy,
  Dummy,			/* 40 */
  ProcWarpPointer,
  ProcSetInputFocus,
  Dummy,
  Dummy,
  ProcOpenFont,			/* 45 */
  ProcCloseFont,
  Dummy,
  Dummy,
  Dummy,
  Dummy,			/* 50 */
  ProcSetFontPath,
  Dummy,
  ProcCreatePixmap,
  ProcFreePixmap,
  ProcCreateGC,			/* 55 */
  ProcChangeGC,
  ProcCopyGC,
  ProcSetDashes,
  ProcSetClipRectangles,
  ProcFreeGC,			/* 60 */
  ProcClearToBackground,
  ProcCopyArea,
  ProcCopyPlane,
  ProcPolyPoint,
  ProcPolyLine,			/* 65 */
  ProcPolySegment,
  ProcPolyRectangle,
  ProcPolyArc,
  ProcFillPoly,
  ProcPolyFillRectangle,	/* 70 */
  ProcPolyFillArc,
  ProcPutImage,
  Dummy,
  ProcPolyText,
  ProcPolyText,			/* 75 */
  ProcImageText,
  ProcImageText,
  ProcCreateColormap,
  ProcFreeColormap,
  ProcCopyColormapAndFree,	/* 80 */
  ProcInstallColormap,
  ProcUninstallColormap,
  Dummy,
  Dummy,
  Dummy,			/* 85 */
  Dummy,
  Dummy,
  ProcFreeColors,
  ProcStoreColors,
  ProcStoreNamedColor,		/* 90 */
  Dummy,
  Dummy,
  ProcCreateCursor,
  ProcCreateGlyphCursor,
  ProcFreeCursor,		/* 95 */
  ProcRecolorCursor,
  Dummy,
  Dummy,
  Dummy,
  ProcChangeKeyboardMapping,	/* 100 */
  Dummy,
  ProcChangeKeyboardControl,
  Dummy,
  ProcBell,
  ProcChangePointerControl,	/* 105 */
  Dummy,
  ProcSetScreenSaver,
  Dummy,
  ProcChangeHosts,
  Dummy,			/* 110 */
  ProcChangeAccessControl,
  ProcChangeCloseDownMode,
  ProcKillClient,
  ProcRotateProperties,
  ProcForceScreenSaver,		/* 115 */
  Dummy,
  Dummy,
  Dummy,
  Dummy,
  0,				/* 120 */
  0,
  0,
  0,
  0,
  0,				/* 125 */
  0,
  ProcNoOperation
};
